Index: libgomp/ChangeLog
===================================================================
--- libgomp/ChangeLog	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libgomp/ChangeLog	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,3 +1,12 @@
+2013-05-16  Jakub Jelinek  <jakub@redhat.com>
+
+	* testsuite/libgomp.c/loop-13.c: New test.
+	* testsuite/libgomp.c/loop-14.c: New test.
+	* testsuite/libgomp.c/loop-15.c: New test.
+	* testsuite/libgomp.c++/loop-13.C: New test.
+	* testsuite/libgomp.c++/loop-14.C: New test.
+	* testsuite/libgomp.c++/loop-15.C: New test.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
Index: libgomp/testsuite/libgomp.c++/loop-14.C
===================================================================
--- libgomp/testsuite/libgomp.c++/loop-14.C	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libgomp/testsuite/libgomp.c++/loop-14.C	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,3 @@
+/* { dg-do run } */
+
+#include "../libgomp.c/loop-14.c"
Index: libgomp/testsuite/libgomp.c++/loop-13.C
===================================================================
--- libgomp/testsuite/libgomp.c++/loop-13.C	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libgomp/testsuite/libgomp.c++/loop-13.C	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,3 @@
+/* { dg-do run } */
+
+#include "../libgomp.c/loop-13.c"
Index: libgomp/testsuite/libgomp.c++/loop-15.C
===================================================================
--- libgomp/testsuite/libgomp.c++/loop-15.C	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libgomp/testsuite/libgomp.c++/loop-15.C	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,3 @@
+/* { dg-do run } */
+
+#include "../libgomp.c/loop-15.c"
Index: libgomp/testsuite/libgomp.c/loop-15.c
===================================================================
--- libgomp/testsuite/libgomp.c/loop-15.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libgomp/testsuite/libgomp.c/loop-15.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,253 @@
+/* { dg-do run } */
+
+volatile int ji = 100, ki = 2;
+volatile unsigned int ju = 100, ku = 2;
+volatile long long int jll = 100, kll = 2;
+volatile unsigned long long int jull = 100, kull = 2;
+unsigned long long l;
+
+void
+f0 (void)
+{
+  int i, j, k;
+  unsigned int j2, k2;
+  #pragma omp for reduction(+: l) schedule(runtime)
+  for (i = ji; i < ki; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(runtime)
+  for (i = ji; i < ki; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ji; i < ki; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ji; i < ki; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = ki + 10; k < ji - 10; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = ki + 10; j < ji - 10; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f1 (void)
+{
+  unsigned int i, j, k;
+  int j2, k2;
+  #pragma omp for reduction(+: l) schedule(runtime)
+  for (i = ju; i < ku; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(runtime)
+  for (i = ju; i < ku; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ju; i < ku; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ju; i < ku; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = ku; k < ju; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = ku; j < ju; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f2 (void)
+{
+  long long int i, j, k;
+  unsigned long long int j2, k2;
+  #pragma omp for reduction(+: l) schedule(runtime)
+  for (i = jll; i < kll; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(runtime)
+  for (i = jll; i < kll; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jll; i < kll; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jll; i < kll; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = kll; k < jll; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = kll; j < jll; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f3 (void)
+{
+  unsigned long long int i, j, k;
+  long long int j2, k2;
+  #pragma omp for reduction(+: l) schedule(runtime)
+  for (i = jull; i < kull; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(runtime)
+  for (i = jull; i < kull; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jull; i < kull; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jull; i < kull; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = kull; k < jull; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(runtime)
+  for (j = kull; j < jull; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+int
+main ()
+{
+  f0 ();
+  f1 ();
+  f2 ();
+  f3 ();
+  return 0;
+}
Index: libgomp/testsuite/libgomp.c/loop-13.c
===================================================================
--- libgomp/testsuite/libgomp.c/loop-13.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libgomp/testsuite/libgomp.c/loop-13.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,253 @@
+/* { dg-do run } */
+
+volatile int ji = 100, ki = 2;
+volatile unsigned int ju = 100, ku = 2;
+volatile long long int jll = 100, kll = 2;
+volatile unsigned long long int jull = 100, kull = 2;
+unsigned long long l;
+
+void
+f0 (void)
+{
+  int i, j, k;
+  unsigned int j2, k2;
+  #pragma omp for reduction(+: l)
+  for (i = ji; i < ki; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l)
+  for (i = ji; i < ki; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ji; i < ki; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ji; i < ki; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = ki + 10; k < ji - 10; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = ki + 10; j < ji - 10; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f1 (void)
+{
+  unsigned int i, j, k;
+  int j2, k2;
+  #pragma omp for reduction(+: l)
+  for (i = ju; i < ku; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l)
+  for (i = ju; i < ku; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ju; i < ku; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ju; i < ku; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = ku; k < ju; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = ku; j < ju; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f2 (void)
+{
+  long long int i, j, k;
+  unsigned long long int j2, k2;
+  #pragma omp for reduction(+: l)
+  for (i = jll; i < kll; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l)
+  for (i = jll; i < kll; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jll; i < kll; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jll; i < kll; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = kll; k < jll; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = kll; j < jll; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f3 (void)
+{
+  unsigned long long int i, j, k;
+  long long int j2, k2;
+  #pragma omp for reduction(+: l)
+  for (i = jull; i < kull; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l)
+  for (i = jull; i < kull; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jull; i < kull; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jull; i < kull; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = kull; k < jull; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3)
+  for (j = kull; j < jull; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+int
+main ()
+{
+  f0 ();
+  f1 ();
+  f2 ();
+  f3 ();
+  return 0;
+}
Index: libgomp/testsuite/libgomp.c/loop-14.c
===================================================================
--- libgomp/testsuite/libgomp.c/loop-14.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libgomp/testsuite/libgomp.c/loop-14.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,253 @@
+/* { dg-do run } */
+
+volatile int ji = 100, ki = 2;
+volatile unsigned int ju = 100, ku = 2;
+volatile long long int jll = 100, kll = 2;
+volatile unsigned long long int jull = 100, kull = 2;
+unsigned long long l;
+
+void
+f0 (void)
+{
+  int i, j, k;
+  unsigned int j2, k2;
+  #pragma omp for reduction(+: l) schedule(static, 2)
+  for (i = ji; i < ki; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(static, 2)
+  for (i = ji; i < ki; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ji; i < ki; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ji; i < ki; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = ji; i < ki; i++)
+      for (k = ki + 10; k < ji - 10; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = ki + 10; j < ji - 10; j++)
+    for (i = ji; i < ki; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f1 (void)
+{
+  unsigned int i, j, k;
+  int j2, k2;
+  #pragma omp for reduction(+: l) schedule(static, 2)
+  for (i = ju; i < ku; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(static, 2)
+  for (i = ju; i < ku; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ju; i < ku; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = ju; i < ku; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = ju; i < ku; i++)
+      for (k = ku; k < ju; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = ku; j < ju; j++)
+    for (i = ju; i < ku; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f2 (void)
+{
+  long long int i, j, k;
+  unsigned long long int j2, k2;
+  #pragma omp for reduction(+: l) schedule(static, 2)
+  for (i = jll; i < kll; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(static, 2)
+  for (i = jll; i < kll; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jll; i < kll; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jll; i < kll; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = jll; i < kll; i++)
+      for (k = kll; k < jll; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = kll; j < jll; j++)
+    for (i = jll; i < kll; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+void
+f3 (void)
+{
+  unsigned long long int i, j, k;
+  long long int j2, k2;
+  #pragma omp for reduction(+: l) schedule(static, 2)
+  for (i = jull; i < kull; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) schedule(static, 2)
+  for (i = jull; i < kull; i++)
+    l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jull; i < kull; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j2 = 0; j2 < 4; j2++)
+    for (i = jull; i < kull; i++)
+      for (k2 = 0; k2 < 5; k2 += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = 0; j < 4; j++)
+    for (i = jull; i < kull; i++)
+      for (k = kull; k < jull; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+  #pragma omp parallel for reduction(+: l) collapse(3) schedule(static, 2)
+  for (j = kull; j < jull; j++)
+    for (i = jull; i < kull; i++)
+      for (k = 0; k < 5; k += 2)
+	l++;
+  if (l != 0)
+    __builtin_abort ();
+}
+
+int
+main ()
+{
+  f0 ();
+  f1 ();
+  f2 ();
+  f3 ();
+  return 0;
+}
Index: libsanitizer/ChangeLog
===================================================================
--- libsanitizer/ChangeLog	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libsanitizer/ChangeLog	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,3 +1,13 @@
+2013-03-22  Jakub Jelinek  <jakub@redhat.com>
+
+	PR other/43620
+	* configure.ac (AM_INIT_AUTOMAKE): Add no-dist.
+	* Makefile.in: Regenerated.
+	* asan/Makefile.in: Regenerated.
+	* interception/Makefile.in: Regenerated.
+	* sanitizer_common/Makefile.in: Regenerated.
+	* tsan/Makefile.in: Regenerated.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
Index: libsanitizer/configure.ac
===================================================================
--- libsanitizer/configure.ac	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libsanitizer/configure.ac	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -23,7 +23,7 @@
 AC_SUBST(target_alias)
 GCC_LIBSTDCXX_RAW_CXX_FLAGS
 
-AM_INIT_AUTOMAKE(foreign)
+AM_INIT_AUTOMAKE(foreign no-dist)
 AM_ENABLE_MULTILIB(, ..)
 AM_MAINTAINER_MODE
 
Index: libstdc++-v3/src/c++11/system_error.cc
===================================================================
--- libstdc++-v3/src/c++11/system_error.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/src/c++11/system_error.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -62,8 +62,8 @@
     }
   };
 
-  const generic_error_category generic_category_instance;
-  const system_error_category system_category_instance;
+  const generic_error_category generic_category_instance{};
+  const system_error_category system_category_instance{};
 }
 
 namespace std _GLIBCXX_VISIBILITY(default)
Index: libstdc++-v3/src/c++11/future.cc
===================================================================
--- libstdc++-v3/src/c++11/future.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/src/c++11/future.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -60,7 +60,7 @@
   const future_error_category&
   __future_category_instance() noexcept
   {
-    static const future_error_category __fec;
+    static const future_error_category __fec{};
     return __fec;
   }
 }
Index: libstdc++-v3/configure.ac
===================================================================
--- libstdc++-v3/configure.ac	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/configure.ac	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -211,12 +211,13 @@
 GLIBCXX_CHECK_SC_NPROC_ONLN
 GLIBCXX_CHECK_PTHREADS_NUM_PROCESSORS_NP
 GLIBCXX_CHECK_SYSCTL_HW_NCPU
+GLIBCXX_CHECK_SDT_H
 
 # Check for available headers.
 AC_CHECK_HEADERS([endian.h execinfo.h float.h fp.h ieeefp.h inttypes.h \
 locale.h machine/endian.h machine/param.h nan.h stdint.h stdlib.h string.h \
 strings.h sys/ipc.h sys/isa_defs.h sys/machine.h sys/param.h \
-sys/resource.h sys/sdt.h sys/sem.h sys/stat.h sys/time.h sys/types.h unistd.h \
+sys/resource.h sys/sem.h sys/stat.h sys/time.h sys/types.h unistd.h \
 wchar.h wctype.h])
 
 # Only do link tests if native. Else, hardcode.
Index: libstdc++-v3/include/debug/array
===================================================================
--- libstdc++-v3/include/debug/array	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/debug/array	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -289,17 +289,11 @@
   // Tuple interface to class template array.
 
   /// tuple_size
-  template<typename _Tp> 
-    class tuple_size;
-
   template<typename _Tp, std::size_t _Nm>
     struct tuple_size<__debug::array<_Tp, _Nm>>
     : public integral_constant<std::size_t, _Nm> { };
 
   /// tuple_element
-  template<std::size_t _Int, typename _Tp>
-    class tuple_element;
-
   template<std::size_t _Int, typename _Tp, std::size_t _Nm>
     struct tuple_element<_Int, __debug::array<_Tp, _Nm>>
     {
Index: libstdc++-v3/include/std/chrono
===================================================================
--- libstdc++-v3/include/std/chrono	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/std/chrono	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -225,7 +225,7 @@
 	{ return numeric_limits<_Rep>::lowest(); }
       };
 
-    template<typename T>
+    template<typename _Tp>
       struct __is_ratio
       : std::false_type
       { };
Index: libstdc++-v3/include/std/mutex
===================================================================
--- libstdc++-v3/include/std/mutex	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/std/mutex	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -45,12 +45,13 @@
 #include <bits/gthr.h>
 #include <bits/move.h> // for std::swap
 
-#if defined(_GLIBCXX_HAS_GTHREADS) && defined(_GLIBCXX_USE_C99_STDINT_TR1)
+#ifdef _GLIBCXX_USE_C99_STDINT_TR1
 
 namespace std _GLIBCXX_VISIBILITY(default)
 {
 _GLIBCXX_BEGIN_NAMESPACE_VERSION
 
+#ifdef _GLIBCXX_HAS_GTHREADS
   // Common base class for std::mutex and std::timed_mutex
   class __mutex_base
   {
@@ -384,6 +385,7 @@
       }
   };
 #endif
+#endif // _GLIBCXX_HAS_GTHREADS
 
   /// Do not acquire ownership of the mutex.
   struct defer_lock_t { };
@@ -719,6 +721,7 @@
         }
     }
 
+#ifdef _GLIBCXX_HAS_GTHREADS
   /// once_flag
   struct once_flag
   {
@@ -790,13 +793,13 @@
       if (__e)
 	__throw_system_error(__e);
     }
+#endif // _GLIBCXX_HAS_GTHREADS
 
   // @} group mutexes
 _GLIBCXX_END_NAMESPACE_VERSION
 } // namespace
+#endif // _GLIBCXX_USE_C99_STDINT_TR1
 
-#endif // _GLIBCXX_HAS_GTHREADS && _GLIBCXX_USE_C99_STDINT_TR1
-
 #endif // C++11
 
 #endif // _GLIBCXX_MUTEX
Index: libstdc++-v3/include/std/functional
===================================================================
--- libstdc++-v3/include/std/functional	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/std/functional	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -227,7 +227,7 @@
 	     (!is_member_pointer<_Functor>::value
 	      && !is_function<_Functor>::value
 	      && !is_function<typename remove_pointer<_Functor>::type>::value),
-	     typename result_of<_Functor(_Args&&...)>::type
+	     typename result_of<_Functor&(_Args&&...)>::type
 	   >::type
     __invoke(_Functor& __f, _Args&&... __args)
     {
Index: libstdc++-v3/include/profile/array
===================================================================
--- libstdc++-v3/include/profile/array	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/profile/array	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -251,17 +251,11 @@
   // Tuple interface to class template array.
 
   /// tuple_size
-  template<typename _Tp> 
-    class tuple_size;
-
   template<typename _Tp, std::size_t _Nm>
     struct tuple_size<__profile::array<_Tp, _Nm>>
     : public integral_constant<std::size_t, _Nm> { };
 
   /// tuple_element
-  template<std::size_t _Int, typename _Tp>
-    class tuple_element;
-
   template<std::size_t _Int, typename _Tp, std::size_t _Nm>
     struct tuple_element<_Int, __profile::array<_Tp, _Nm>>
     {
Index: libstdc++-v3/include/bits/stl_list.h
===================================================================
--- libstdc++-v3/include/bits/stl_list.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/bits/stl_list.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1487,7 +1487,11 @@
 			       __false_type)
         {
 	  for (; __first != __last; ++__first)
+#if __cplusplus >= 201103L
+	    emplace_back(*__first);
+#else
 	    push_back(*__first);
+#endif
 	}
 
       // Called by list(n,v,a), and the range constructor when it turns out
Index: libstdc++-v3/include/bits/hashtable_policy.h
===================================================================
--- libstdc++-v3/include/bits/hashtable_policy.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/bits/hashtable_policy.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -644,7 +644,7 @@
 	  __h._M_rehash(__do_rehash.second, __saved_state);
 
 	for (; __first != __last; ++__first)
-	  this->insert(*__first);
+	  __h._M_insert(*__first, __unique_keys());
       }
 
   /**
Index: libstdc++-v3/include/bits/stl_heap.h
===================================================================
--- libstdc++-v3/include/bits/stl_heap.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/bits/stl_heap.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -291,8 +291,11 @@
       __glibcxx_requires_valid_range(__first, __last);
       __glibcxx_requires_heap(__first, __last);
 
-      --__last;
-      std::__pop_heap(__first, __last, __last);
+      if (__last - __first > 1)
+	{
+	  --__last;
+	  std::__pop_heap(__first, __last, __last);
+	}
     }
 
   template<typename _RandomAccessIterator, typename _Distance,
@@ -363,8 +366,11 @@
       __glibcxx_requires_non_empty_range(__first, __last);
       __glibcxx_requires_heap_pred(__first, __last, __comp);
 
-      --__last;
-      std::__pop_heap(__first, __last, __last, __comp);
+      if (__last - __first > 1)
+	{
+	  --__last;
+	  std::__pop_heap(__first, __last, __last, __comp);
+	}
     }
 
   /**
